import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.DriverManager;
import java.sql.Statement;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;

public class test_float_pg
	{
	public static void print(String s)
		{
		System.out.println(s);
		}



	public static boolean test(String db_url, String user, String passwd) throws SQLException
		{
		print("\n\ntest JDBC");
		print("classpath=" + System.getProperty("java.class.path", "."));

		Connection db = DriverManager.getConnection(db_url, user, passwd);
		try
			{
			DatabaseMetaData dbmi = db.getMetaData();
			print("JDBC driver version is '" + dbmi.getDriverVersion() + "'; major: " + dbmi.getDriverMajorVersion() + "; minor: " + dbmi.getDriverMinorVersion());

			String last_s = "";
			int i = 0;
			long t0 = System.currentTimeMillis();
			while (true)
				{
				i += 1;
				// code that is prepared on server side
				PreparedStatement pstmt = db.prepareStatement("SELECT (EXTRACT(EPOCH FROM timeofday()::timestamp(3))*1000) AS timestamp");
				ResultSet rs = pstmt.executeQuery();

				// code that is NOT prepared on server side
				//Statement pstmt = db.createStatement();
				//ResultSet rs = pstmt.executeQuery("SELECT (EXTRACT(EPOCH FROM timeofday()::timestamp(3))*1000) AS timestamp");

				if (i == 1)
					{
					ResultSetMetaData rsmd = rs.getMetaData();
					int type_id = rsmd.getColumnType(1);
					String type_name = rsmd.getColumnTypeName(1);
					print("column type: " + type_name + " (" + type_id + ")");
					}
				while (rs.next())
					{
					String s = rs.getString("timestamp");
					if (!s.equals(last_s))
						{
						long t2 = System.currentTimeMillis();
						if (t2 - t0 > 2000)
							{
							print("epoch: " + s + "; tries: " + i);
							t0 = t2;
							}
						if (s.indexOf(".") >= 0)
							{
							// check if ResultSetMetaData changed
							ResultSetMetaData rsmd = rs.getMetaData();
							int type_id = rsmd.getColumnType(1);
							String type_name = rsmd.getColumnTypeName(1);
							print("column type: " + type_name + " (" + type_id + ")");

							// show last data
							print("last: " + last_s + "; tries: " + i);
							print("!!!" + s + "!!!");
							return true;
							}
						last_s = s;
						}
					}
				rs.close();
				pstmt.close();
				}
			}
		finally
			{
			db.close();
			}
		}



	public static void main(String[] args)
		{
		try
			{
			test("jdbc:postgresql://test-baza.heuthesd:5494/isof_test?stringtype=unspecified&prepareThreshold=3", "postgres", "postgres");
			}
		catch (SQLException e)
			{
			e.printStackTrace();
			}
		}
	}
